## toulbar2 1.1.0+dfsg

=== CMakeLists.txt ===
##########################################
# cmake file for toulbar2 building, testing and packaging
# version 0.9 -# David allouche 17/10/10
##########################################

cmake_minimum_required(VERSION 2.6)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set (My_cmake_script "${CMAKE_CURRENT_SOURCE_DIR}/cmake-script") # location of cmake script needed 
set (My_Source src)	# source location 
set (doc_destination "share/doc")   #path of doc installation 
set (My_misc_source misc/src/)
list(APPEND CMAKE_MODULE_PATH "${My_cmake_script}/Modules")

set (MAINTAINER "David Allouche <david.allouche@inrae.fr>") #used in packaging 
set (CONTACT "https://github.com/toulbar2/toulbar2") #used in packaging

##########################################
# PROJECT NAME
##########################################

project("toulbar2")

MESSAGE(STATUS "##########################################")
MESSAGE(STATUS "project :${PROJECT_NAME} toolkit compilation cmake file version 0.99")
MESSAGE(STATUS "source:${CMAKE_CURRENT_SOURCE_DIR} ")
MESSAGE(STATUS "MAKE_BUILD_TYPE : ${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "##########################################")

include(CMakeDependentOption)

##########################################
# cmake option definition
##########################################
#	OPTION(TOULBAR2 "toulbar2 solver compilation [default: on]" ON) 
OPTION(WIN32 "toulbar2 cross compilation flag [default: off]" OFF) 
OPTION(MENDELSOFT "mendelsoft compilation and packaging ONLY ==> remove other exe and lib compilation [default:off]" OFF)
OPTION(LIBTB2 "lib toulbar2 compilation [default: off]" OFF)
OPTION(PYTB2 "Python3 toulbar2 module compilation (MPI off) [default: off]" OFF)
OPTION(ILOG  "ilog solver binding [default: off]" OFF)
OPTION(XML "add a reader for the (W)CSP xml input format [default: off]" OFF)
OPTION(CPLEX "encode global cost functions into a linear program solved by CPLEX [default: off]" OFF)
OPTION(Boost "boost graph binding [default: on]" ON) 
OPTION(MPI "MPI [default: off]" OFF)
OPTION(LONG_COSTS  "use long long to encode costs [default:on]" ON)
OPTION(LONG_PROBABILITY  "use long double to encode probabilities [default:on]" ON)
OPTION(QUAD_PROBABILITY  "use quadmath to encode probabilities [default:off]" OFF)
OPTION(BUILD_API_DOC "build and install HTML documentation with doxygen [default:off]" OFF)
OPTION(BUILD_API_DOC_LATEX "build and install LaTeX PDF documentation with doxygen [default:off]" OFF)
OPTION(STATIC "static compilation flag [default: off]" OFF)
OPTION(verbose "verbose mode [default:on]" ON)
OPTION(COVER_TEST "cover test [default:on]" ON)
OPTION(BENCH "benchmarcking [default:off]" OFF)
OPTION(WITH_MEM_JEMALLOC "Enable malloc replacement (http://www.canonware.com/jemalloc) [default on]" ON)

MARK_AS_ADVANCED(FORCE BUILD_API_DOC_LATEX)
MARK_AS_ADVANCED(FORCE CPLEX ILOG XML verbose Boost FOPT CMAKE_INSTALL_PREFIX LONG_PROBABILITY LONG_COSTS)
MARK_AS_ADVANCED(FORCE BUILD_SHARED_LIBS GMP_LIBRARY MPI_LIBRARY MPI_EXTRA_LIBRARY)
MARK_AS_ADVANCED(FORCE BENCH)

##########################################
#Default profile for compilation
##########################################
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the build type, options are: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++11" )
SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=signed-integer-overflow -fsanitize=float-cast-overflow -g3" )

IF(CPLEX)
  SET(CPLEX_LOCATION "/opt/ibm/ILOG/CPLEX_Studio1271")
  SET(CPLEXFLAGS "-fPIC -fexceptions -fno-strict-aliasing -DILOGCPLEX -DIL_STD -DILOSTRICTPOD -pthread -I${CPLEX_LOCATION}/cplex/include -I${CPLEX_LOCATION}/concert/include")
  SET(CPLEXLIB "-L${CPLEX_LOCATION}/cplex/lib/x86-64_linux/static_pic -L${CPLEX_LOCATION}/concert/lib/x86-64_linux/static_pic") 
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CPLEXFLAGS}")
  SET(CMAKE_EXE_LINKER_FLAGS " ${CPLEXLIB}")
  SET (all_depends  ${all_depends} "ilocplex") 
  SET (all_depends  ${all_depends} "cplex") 
  SET (all_depends  ${all_depends} "concert") 
  SET (all_depends  ${all_depends} "m") 
  SET (all_depends  ${all_depends} "pthread") 
  SET (all_depends  ${all_depends} "boost") 
  SET(STATIC OFF)
ENDIF(CPLEX)

if(verbose) 
  set (CMAKE_VERBOSE_MAKEFILE ON)
endif(verbose)

##########################################
# Compile Options on recent 64 bytes Macs. 
# thanks to alex rudnick 
##########################################
IF(APPLE)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall -m64" )
  SET(STATIC OFF)
  SET(WITH_MEM_JEMALLOC OFF)
ENDIF(APPLE)

##########################################
# default OPTION for toulbar2 test  phase
##########################################
SET(FOPT "test-opt.cmake" CACHE STRING "filename containing local options used for validation")
SET(Default_test_option CACHE STRING "Define toulbar2 option used in command line for testing: cf toulbar2 command line")
SET(Default_test_timeout 300 CACHE STRING "default test timeout")
SET(Default_validation_dir "validation" CACHE STRING "default location of validation files")
SET(Default_cover_dir "cover" CACHE STRING "default location of cover test files")
SET(Default_regexp "end." CACHE STRING "default regex searched in test output")
SET(Default_BenchDir "benchmarks" CACHE STRING "default location of benchmark files")
SET(Default_BenchFormat "wcsp" CACHE STRING "default format extension for benchmark files search") 
SET(Default_bench_timeout 30 CACHE STRING "default timeout used for benchmarking ")
SET(Default_bench_option "TOULBAR2_OPTION" CACHE STRING " option used in command line for benchmarking.")
SET(Default_bench_regexp "test ok" CACHE STRING "default regex searched in bench output")
MARK_AS_ADVANCED(FORCE Default_test_option Default_test_timeout Default_validation_dir Default_cover_dir Default_regexp Default_BenchDir Default_BenchFormat Default_bench_timeout Default_bench_option Default_bench_regexp)

##########################################
# static building
##########################################
IF(STATIC)
  MESSAGE(STATUS "STATIC COMPILATION ON (warning: jemalloc, xml, and MPI options not compliant with static link)")
  SET(WITH_MEM_JEMALLOC OFF)
  SET(XML OFF)
  SET(MPI OFF)
  set(Boost_USE_STATIC_LIBS ON)  # only find static libs
  SET(BUILD_SHARED_LIBS OFF)
  set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  set(CMAKE_EXE_LINKER_FLAGS "-static -static-libgcc -static-libstdc++") 
ELSE()
  SET(BUILD_SHARED_LIBS ON) #shared library building
ENDIF(STATIC)

##########################################
# OPTION DEPENDANCES 
##########################################

IF(MENDELSOFT)
  MESSAGE(STATUS "##########################################")
  MESSAGE(STATUS " MENDELSOFT COMPILATION AND PACKAGING ONLY")
  MESSAGE(STATUS "##########################################")
  
  SET(TOULBAR2 OFF)
  SET(ILOG OFF)
  SET(LIBTB2 OFF)
  SET(XML OFF)
  SET(CPLEX OFF)
  SET(Boost OFF)
  SET(MPI OFF)
  
  #basename for packaging and versioning
  set (Toulbar2_NAME "mendelsoft")
  #description used in the package building
  SET (Toulbar2_PACKAGE_DESCRIPTION 
    "MendelSoft is an open source software which detects marker genotyping incompatibilities (Mendelian errors only) in complex pedigrees using weighted constraint satisfaction techniques. The input of the software is a pedigree data with genotyping data at a single locus. The output of the software is a list of individuals for which the removal of their genotyping data restores consistency. This list is of minimum size when the program ends.") 
  SET(Toulbar2_PACKAGE_SUMMARY "${Toulbar2_NAME} is an open source software which detect Mendelian errors in complex pedigrees using weighted constraint satisfaction techniques")
ELSE(MENDELSOFT)
  MESSAGE(STATUS "###############################################")
  MESSAGE(STATUS " TOULBAR2 Solver Compilation and Packaging Only")
  MESSAGE(STATUS "###############################################")

  SET(TOULBAR2 ON)
  #basename for packaging and versionning
  SET(Toulbar2_NAME "toulbar2")
  #description used in the package building
  SET(Toulbar2_PACKAGE_DESCRIPTION "${Toulbar2_NAME} is an open source C++ exact solver and library for discrete graphical model optimization. It can solve MAP/Markov Random Fields or Cost Function Networks/Weighted CSPs/Weighted MaxSAT or Quadratic Pseudo-Boolean Optimization.")
  SET(Toulbar2_PACKAGE_SUMMARY "${Toulbar2_NAME} exact solver for discrete graphical models.")
ENDIF(MENDELSOFT)

IF(ILOG)
  set(LIBTB2 ON)
ENDIF(ILOG)

SET(EXECUTABLE_OUTPUT_PATH bin/${CMAKE_SYSTEM_NAME})
SET(LIBRARY_OUTPUT_PATH lib/${CMAKE_SYSTEM_NAME})

##########################################
# Windows options
##########################################
IF(WIN32)
  # option used for cross compilation 
  set (EXE ".exe")
  set(COST INT_COST)
  set(LIBTB2 OFF)
  set(XML OFF)
  set(CPLEX OFF)
  set(Boost OFF)
  set(MPI OFF)
  set(ILOG OFF)

  # mingW32 env setup
  include(${My_cmake_script}/mingw32-config.cmake) 
  
  MESSAGE(STATUS "WIN32 ON")
ELSE(WIN32)
  SET(COST LONGLONG_COST)
ENDIF(WIN32)

##########################################
# Find optional libs 
##########################################

include(${My_cmake_script}/source_files.cmake)

IF(PYTB2)
  SET(WITH_MEM_JEMALLOC OFF)
  SET(MPI OFF)
  SET(LIBTB2 ON)
  FIND_PACKAGE(Python3 COMPONENTS Interpreter Development)
  EXECUTE_PROCESS(
    COMMAND ${Python3_EXECUTABLE}-config --extension-suffix 
    OUTPUT_VARIABLE Python3_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
  MESSAGE(STATUS "Python3 suffix: ${Python3_SUFFIX}")
  EXECUTE_PROCESS(
    COMMAND ${Python3_EXECUTABLE} -m pybind11 --includes 
    OUTPUT_VARIABLE Pybind11_INCLUDES OUTPUT_STRIP_TRAILING_WHITESPACE)
  MESSAGE(STATUS "Pybind11 includes: ${Pybind11_INCLUDES}")
ENDIF(PYTB2)

IF(WITH_MEM_JEMALLOC)
  find_package(JeMalloc)
  IF(JEMALLOC_FOUND)
    link_directories(${JEMALLOC_LIBPATH})
    SET (all_depends  ${all_depends} "jemalloc") 
  ENDIF(JEMALLOC_FOUND)
ENDIF(WITH_MEM_JEMALLOC)

MESSAGE(STATUS "Search for GMP library")
INCLUDE(FindPkgConfig)
INCLUDE(${My_cmake_script}/FindGmp.cmake)
SET(all_depends  ${all_depends} "gmp") 
INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR}) 

INCLUDE(FindPkgConfig)
INCLUDE(FindGit)

IF(Boost) 
  INCLUDE(${My_cmake_script}/Boost_option.cmake)
  LINK_DIRECTORIES(${Boost_LIBRARY_DIR})
  INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
ENDIF(Boost)

IF(MPI) 
#  SET(CMAKE_C_COMPILER mpicc)
#  SET(CMAKE_CXX_COMPILER mpicxx)
#  SET(CMAKE_CXX_COMPILER /usr/mpi/gcc/openmpi-1.10.3rc4/bin/mpicxx)
#  SET(CMAKE_SYSTEM_PREFIX_PATH /usr/mpi/gcc/openmpi-1.10.3rc4)
  FIND_PACKAGE(MPI REQUIRED)
  INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})
  SET(mpiflag OPENMPI)
ENDIF(MPI)

INCLUDE(${My_cmake_script}/xmlcsp.cmake)


##########################################
# Build executables
##########################################
# the list of source files used to compile is set in source_file.cmake
# new files need to be added to this list

INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_SOURCE_DIR}/${My_Source} )

IF(TOULBAR2)
  ADD_LIBRARY(tb2-objects OBJECT ${LIBTB2FILES})
  ADD_EXECUTABLE(toulbar2${EXE} ${My_Source}/tb2main.cpp $<TARGET_OBJECTS:tb2-objects>)
  ADD_LIBRARY(tb2-archive STATIC $<TARGET_OBJECTS:tb2-objects>)
  ADD_CUSTOM_TARGET(gen_version ALL /bin/sh ${CMAKE_CURRENT_SOURCE_DIR}/cmake-script/genVersionFile.sh)
  SET_SOURCE_FILES_PROPERTIES(ToulbarVersion.hpp PROPERTIES GENERATED 1)
  ADD_DEPENDENCIES(toulbar2${EXE} gen_version)
  IF(MPI)
    TARGET_LINK_LIBRARIES(toulbar2${EXE} ${all_depends} ${MPI_LIBRARIES})
    IF(MPI_COMPILE_FLAGS)
      set_target_properties(toulbar2${EXE} PROPERTIES COMPILE_FLAGS "${MPI_COMPILE_FLAGS}")
    ENDIF(MPI_COMPILE_FLAGS)
    IF(MPI_LINK_FLAGS)
      set_target_properties(toulbar2${EXE} PROPERTIES LINK_FLAGS "${MPI_LINK_FLAGS}")
    ENDIF(MPI_LINK_FLAGS)
  ELSE(MPI)
