=== debian/changelog ===
toulbar2 (1.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.0
  * Adding new dependencies to control, and new options to compilation rules
  * Removing pre-push hook, useless for debian
  * Supposedly improved watch file
  * Recovering doc
  * Avoiding version generation
  * New upstream version 1.1.0+dfsg
  * Old patches removed, git-hooks excluded
  * New upstream version 1.1.0+dfsg

 -- Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>  Fri, 30 Oct 2020 10:14:29 +0000
