## toulbar2 1.1.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,8 @@
 
 set (MAINTAINER "David Allouche <david.allouche@inrae.fr>") #used in packaging 
 set (CONTACT "https://github.com/toulbar2/toulbar2") #used in packaging
+# default name for packaging
+SET(Toulbar2_NAME "toulbar2")
 
 ##########################################
 # PROJECT NAME
@@ -21,8 +23,8 @@
 project("toulbar2")
 
 MESSAGE(STATUS "##########################################")
-MESSAGE(STATUS "project :${PROJECT_NAME} toolkit compilation cmake file version 0.99")
-MESSAGE(STATUS "source:${CMAKE_CURRENT_SOURCE_DIR} ")
+MESSAGE(STATUS "project: ${PROJECT_NAME} toolkit compilation cmake file version 0.99")
+MESSAGE(STATUS "source: ${CMAKE_CURRENT_SOURCE_DIR} ")
 MESSAGE(STATUS "MAKE_BUILD_TYPE : ${CMAKE_BUILD_TYPE}")
 MESSAGE(STATUS "##########################################")
 
@@ -32,7 +34,6 @@
 # cmake option definition
 ##########################################
 #	OPTION(TOULBAR2 "toulbar2 solver compilation [default: on]" ON) 
-OPTION(WIN32 "toulbar2 cross compilation flag [default: off]" OFF) 
 OPTION(MENDELSOFT "mendelsoft compilation and packaging ONLY ==> remove other exe and lib compilation [default:off]" OFF)
 OPTION(LIBTB2 "lib toulbar2 compilation [default: off]" OFF)
 OPTION(PYTB2 "Python3 toulbar2 module compilation (MPI off) [default: off]" OFF)
@@ -60,6 +61,10 @@
 ##########################################
 #Default profile for compilation
 ##########################################
+IF(APPLE) # Find homebrew libraries first
+  set(CMAKE_PREFIX_PATH /usr/local)
+ENDIF(APPLE)
+
 IF(NOT CMAKE_BUILD_TYPE)
   SET(CMAKE_BUILD_TYPE Release CACHE STRING
       "Choose the build type, options are: None Debug Release RelWithDebInfo MinSizeRel."
@@ -68,6 +73,7 @@
 
 SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++11" )
 SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=signed-integer-overflow -fsanitize=float-cast-overflow -g3" )
+#SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -flto" )
 
 IF(CPLEX)
   SET(CPLEX_LOCATION "/opt/ibm/ILOG/CPLEX_Studio1271")
@@ -94,7 +100,7 @@
 ##########################################
 IF(APPLE)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
-  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall -m64" )
+  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall -m64 -undefined dynamic_lookup" )
   SET(STATIC OFF)
   SET(WITH_MEM_JEMALLOC OFF)
 ENDIF(APPLE)
@@ -126,9 +132,10 @@
   set(Boost_USE_STATIC_LIBS ON)  # only find static libs
   SET(BUILD_SHARED_LIBS OFF)
   set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
-  set(CMAKE_EXE_LINKER_FLAGS "-static -static-libgcc -static-libstdc++") 
+  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static --enable-static -static-libgcc -static-libstdc++")   # -flto 
 ELSE()
   SET(BUILD_SHARED_LIBS ON) #shared library building
+  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall")   # -flto
 ENDIF(STATIC)
 
 ##########################################
@@ -149,7 +156,7 @@
   SET(MPI OFF)
   
   #basename for packaging and versioning
-  set (Toulbar2_NAME "mendelsoft")
+  set(Toulbar2_NAME "mendelsoft")
   #description used in the package building
   SET (Toulbar2_PACKAGE_DESCRIPTION 
     "MendelSoft is an open source software which detects marker genotyping incompatibilities (Mendelian errors only) in complex pedigrees using weighted constraint satisfaction techniques. The input of the software is a pedigree data with genotyping data at a single locus. The output of the software is a list of individuals for which the removal of their genotyping data restores consistency. This list is of minimum size when the program ends.") 
@@ -160,11 +167,9 @@
   MESSAGE(STATUS "###############################################")
 
   SET(TOULBAR2 ON)
-  #basename for packaging and versionning
-  SET(Toulbar2_NAME "toulbar2")
   #description used in the package building
   SET(Toulbar2_PACKAGE_DESCRIPTION "${Toulbar2_NAME} is an open source C++ exact solver and library for discrete graphical model optimization. It can solve MAP/Markov Random Fields or Cost Function Networks/Weighted CSPs/Weighted MaxSAT or Quadratic Pseudo-Boolean Optimization.")
-  SET(Toulbar2_PACKAGE_SUMMARY "${Toulbar2_NAME} exact solver for discrete graphical models.")
+  SET(Toulbar2_PACKAGE_SUMMARY "${Toulbar2_NAME} is an exact solver for discrete graphical models.")
 ENDIF(MENDELSOFT)
 
 IF(ILOG)
@@ -173,28 +178,6 @@
 
 SET(EXECUTABLE_OUTPUT_PATH bin/${CMAKE_SYSTEM_NAME})
 SET(LIBRARY_OUTPUT_PATH lib/${CMAKE_SYSTEM_NAME})
-
-##########################################
-# Windows options
-##########################################
-IF(WIN32)
-  # option used for cross compilation 
-  set (EXE ".exe")
-  set(COST INT_COST)
-  set(LIBTB2 OFF)
-  set(XML OFF)
-  set(CPLEX OFF)
-  set(Boost OFF)
-  set(MPI OFF)
-  set(ILOG OFF)
-
-  # mingW32 env setup
-  include(${My_cmake_script}/mingw32-config.cmake) 
-  
-  MESSAGE(STATUS "WIN32 ON")
-ELSE(WIN32)
-  SET(COST LONGLONG_COST)
-ENDIF(WIN32)
 
 ##########################################
 # Find optional libs 
@@ -207,6 +190,7 @@
   SET(MPI OFF)
   SET(LIBTB2 ON)
   FIND_PACKAGE(Python3 COMPONENTS Interpreter Development)
+### Old cmake, python and pybind11
   EXECUTE_PROCESS(
     COMMAND ${Python3_EXECUTABLE}-config --extension-suffix 
     OUTPUT_VARIABLE Python3_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
@@ -215,6 +199,9 @@
     COMMAND ${Python3_EXECUTABLE} -m pybind11 --includes 
     OUTPUT_VARIABLE Pybind11_INCLUDES OUTPUT_STRIP_TRAILING_WHITESPACE)
   MESSAGE(STATUS "Pybind11 includes: ${Pybind11_INCLUDES}")
+### New cmake and python and pybind11
+#  FIND_PACKAGE(pybind11 CONFIG)
+###
 ENDIF(PYTB2)
 
 IF(WITH_MEM_JEMALLOC)
@@ -228,7 +215,7 @@
 MESSAGE(STATUS "Search for GMP library")
 INCLUDE(FindPkgConfig)
 INCLUDE(${My_cmake_script}/FindGmp.cmake)
-SET(all_depends  ${all_depends} "gmp") 
+SET(all_depends  ${all_depends} ${GMP_LIBRARY}) 
 INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR}) 
 
 INCLUDE(FindPkgConfig)
@@ -264,6 +251,9 @@
 IF(TOULBAR2)
   ADD_LIBRARY(tb2-objects OBJECT ${LIBTB2FILES})
   ADD_EXECUTABLE(toulbar2${EXE} ${My_Source}/tb2main.cpp $<TARGET_OBJECTS:tb2-objects>)
+  IF(STATIC)
+    TARGET_LINK_LIBRARIES(toulbar2${EXE} PUBLIC "-static")
+  ENDIF(STATIC)
   ADD_LIBRARY(tb2-archive STATIC $<TARGET_OBJECTS:tb2-objects>)
   ADD_CUSTOM_TARGET(gen_version ALL /bin/sh ${CMAKE_CURRENT_SOURCE_DIR}/cmake-script/genVersionFile.sh)
   SET_SOURCE_FILES_PROPERTIES(ToulbarVersion.hpp PROPERTIES GENERATED 1)
@@ -277,3 +267,6 @@
       set_target_properties(toulbar2${EXE} PROPERTIES LINK_FLAGS "${MPI_LINK_FLAGS}")
     ENDIF(MPI_LINK_FLAGS)
   ELSE(MPI)
+    TARGET_LINK_LIBRARIES(toulbar2${EXE} ${all_depends})
+  ENDIF(MPI)
+
