=== contrib/simpleini/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 CC = g++
 
-CFLAGS = -std=c++11 -g -Wall -I../../src -DBOOST -DLINUX -DLONGLONG_COST -DLONGDOUBLE_PROB -DWCSPFORMATONLY
+CFLAGS = -std=c++11 -g -Wall -I../../src -DBOOST -DLONGLONG_COST -DLONGDOUBLE_PROB -DWCSPFORMATONLY
 
 OFLAGS = -O3 -DNDEBUG
