=== debian/changelog ===
toulbar2 (1.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.1

 -- Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>  Tue, 19 Jan 2021 14:06:11 +0000
