=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
                -DXML=ON \
		-DMPI=OFF \
		-DBUILD_API_DOC:STRING=ON \
		-DBUILD_API_DOC_LATEX:STRING=ON
