## toulbar2 1.2.1%2Bdfsg

=== debian/changelog ===
toulbar2 (1.2.1+dfsg-0.1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:07:12 +0200

toulbar2 (1.2.1+dfsg-0.1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:56:50 +0200

toulbar2 (1.2.1+dfsg-0.1) unstable; urgency=medium

  [ Thomas Schiex ]
  * New upstream version 1.2.1.
  * Added sphinx generated doc.
  * Includes bz2 library for proper decompression.
  * Removed useless misc directory from dfsg archive (avoids lintian error).  

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.
  * Set upstream metadata fields: Repository.

 -- Thomas Schiex <thomas.schiex@toulouse.inra.fr>  Wed, 03 Jan 2024 03:13:53 +0530
