## toulbar2 1.2.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,12 @@
 # version 0.9 -# David allouche 17/10/10
 ##########################################
 
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.9)
+IF(APPLE)
+    cmake_minimum_required(VERSION 3.13)
+ENDIF(APPLE)
+cmake_policy(SET CMP0054 NEW)
+
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 set (My_cmake_script "${CMAKE_CURRENT_SOURCE_DIR}/cmake-script") # location of cmake script needed 
 set (My_Source src)	# source location 
@@ -15,13 +20,12 @@
 set (CONTACT "https://github.com/toulbar2/toulbar2") #used in packaging
 # default name for packaging
 SET(Toulbar2_NAME "toulbar2")
-
+SET(CMAKE_MACOSX_RPATH 1)
 ##########################################
 # PROJECT NAME
 ##########################################
 
 project("toulbar2")
-
 MESSAGE(STATUS "##########################################")
 MESSAGE(STATUS "project: ${PROJECT_NAME} toolkit compilation cmake file version 0.99")
 MESSAGE(STATUS "source: ${CMAKE_CURRENT_SOURCE_DIR} ")
@@ -29,7 +33,6 @@
 MESSAGE(STATUS "##########################################")
 
 include(CMakeDependentOption)
-
 ##########################################
 # cmake option definition
 ##########################################
@@ -38,15 +41,21 @@
 OPTION(LIBTB2 "lib toulbar2 compilation [default: off]" OFF)
 OPTION(PYTB2 "Python3 toulbar2 module compilation (MPI off) [default: off]" OFF)
 OPTION(ILOG  "ilog solver binding [default: off]" OFF)
-OPTION(XML "add a reader for the (W)CSP xml input format [default: off]" OFF)
+OPTION(XML "add a reader for the XCSP2/3 xml input format [default: off]" OFF)
+OPTION(XCSP3 "select XCSP3 format instead of XCSP2 [default: on]" ON)
 OPTION(CPLEX "encode global cost functions into a linear program solved by CPLEX [default: off]" OFF)
 OPTION(Boost "boost graph binding [default: on]" ON) 
 OPTION(MPI "MPI [default: off]" OFF)
 OPTION(LONG_COSTS  "use long long to encode costs [default:on]" ON)
+OPTION(SHORT_COSTS  "use short int to encode costs [default:off]" OFF)
+OPTION(BINARYWCSP  "do not store binary costs (only binary WCSP with no variable elimination during search) [default:off]" OFF)
+OPTION(TERNARYWCSP  "do not store ternary costs (only ternary WCSP can be expressed) [default:off]" OFF)
+OPTION(SHORT_VALUES  "use short int to encode domain values instead of int [default:off]" OFF)
 OPTION(LONG_PROBABILITY  "use long double to encode probabilities [default:on]" ON)
 OPTION(QUAD_PROBABILITY  "use quadmath to encode probabilities [default:off]" OFF)
 OPTION(BUILD_API_DOC "build and install HTML documentation with doxygen [default:off]" OFF)
 OPTION(BUILD_API_DOC_LATEX "build and install LaTeX PDF documentation with doxygen [default:off]" OFF)
+OPTION(BUILD_SPHINX_DOC "build Sphinx documentation[default:off]" OFF)
 OPTION(STATIC "static compilation flag [default: off]" OFF)
 OPTION(verbose "verbose mode [default:on]" ON)
 OPTION(COVER_TEST "cover test [default:on]" ON)
@@ -54,7 +63,7 @@
 OPTION(WITH_MEM_JEMALLOC "Enable malloc replacement (http://www.canonware.com/jemalloc) [default on]" ON)
 
 MARK_AS_ADVANCED(FORCE BUILD_API_DOC_LATEX)
-MARK_AS_ADVANCED(FORCE CPLEX ILOG XML verbose Boost FOPT CMAKE_INSTALL_PREFIX LONG_PROBABILITY LONG_COSTS)
+MARK_AS_ADVANCED(FORCE CPLEX ILOG XML XCSP3 verbose Boost FOPT CMAKE_INSTALL_PREFIX LONG_PROBABILITY LONG_COSTS SHORT_COSTS SHORT_VALUES NO_STORE_BINARY_COSTS NO_STORE_TERNARY_COSTS BINARYWCSP TERNARYWCSP)
 MARK_AS_ADVANCED(FORCE BUILD_SHARED_LIBS GMP_LIBRARY MPI_LIBRARY MPI_EXTRA_LIBRARY)
 MARK_AS_ADVANCED(FORCE BENCH)
 
@@ -62,8 +71,19 @@
 #Default profile for compilation
 ##########################################
 IF(APPLE) # Find homebrew libraries first
+  message(STATUS "Apple/MacOS system detected. Selecting homebrew libraries first.")
   set(CMAKE_PREFIX_PATH /usr/local)
+  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
+  SET(STATIC OFF)
+  SET(WITH_MEM_JEMALLOC OFF)
 ENDIF(APPLE)
+
+IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/conan_paths.cmake)
+   message("Conan setup detected.")
+   INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/conan_paths.cmake)
+ELSE()
+   message("Conan file not found in ${CMAKE_CURRENT_SOURCE_DIR} - assuming conan free build.")
+ENDIF()
 
 IF(NOT CMAKE_BUILD_TYPE)
   SET(CMAKE_BUILD_TYPE Release CACHE STRING
@@ -71,12 +91,13 @@
     FORCE)
 ENDIF(NOT CMAKE_BUILD_TYPE)
 
-SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++11" )
-SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=signed-integer-overflow -fsanitize=float-cast-overflow -g3" )
+SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++17" )
+# -fsanitize=address -fsanitize=undefined -Wconversion -Wsign-conversion
+SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize-undefined-trap-on-error -fsanitize=signed-integer-overflow -fsanitize=float-cast-overflow -g3" )
 #SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -flto" )
 
 IF(CPLEX)
-  SET(CPLEX_LOCATION "/opt/ibm/ILOG/CPLEX_Studio1271")
+  SET(CPLEX_LOCATION "/opt/ibm/ILOG/CPLEX_Studio1210")
   SET(CPLEXFLAGS "-fPIC -fexceptions -fno-strict-aliasing -DILOGCPLEX -DIL_STD -DILOSTRICTPOD -pthread -I${CPLEX_LOCATION}/cplex/include -I${CPLEX_LOCATION}/concert/include")
   SET(CPLEXLIB "-L${CPLEX_LOCATION}/cplex/lib/x86-64_linux/static_pic -L${CPLEX_LOCATION}/concert/lib/x86-64_linux/static_pic") 
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CPLEXFLAGS}")
@@ -86,24 +107,13 @@
   SET (all_depends  ${all_depends} "concert") 
   SET (all_depends  ${all_depends} "m") 
   SET (all_depends  ${all_depends} "pthread") 
-  SET (all_depends  ${all_depends} "boost") 
+  SET (all_depends  ${all_depends} "dl") 
   SET(STATIC OFF)
 ENDIF(CPLEX)
 
 if(verbose) 
   set (CMAKE_VERBOSE_MAKEFILE ON)
 endif(verbose)
-
-##########################################
-# Compile Options on recent 64 bytes Macs. 
-# thanks to alex rudnick 
-##########################################
-IF(APPLE)
-  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
-  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall -m64 -undefined dynamic_lookup" )
-  SET(STATIC OFF)
-  SET(WITH_MEM_JEMALLOC OFF)
-ENDIF(APPLE)
 
 ##########################################
 # default OPTION for toulbar2 test  phase
@@ -131,11 +141,16 @@
   SET(MPI OFF)
   set(Boost_USE_STATIC_LIBS ON)  # only find static libs
   SET(BUILD_SHARED_LIBS OFF)
+  set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
   set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
-  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static --enable-static -static-libgcc -static-libstdc++")   # -flto 
-ELSE()
+  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static --disable-shared --enable-static -static-libgcc -static-libstdc++")   # -flto 
+  SET (all_depends  ${all_depends} "z") 
+  SET (all_depends  ${all_depends} "m") 
+  SET (all_depends  ${all_depends} "pthread") 
+  SET (all_depends  ${all_depends} "dl") # it should be present at the end of library ordering (checks manually no dynamic flags occur in the final link command)
+ELSE(STATIC)
   SET(BUILD_SHARED_LIBS ON) #shared library building
-  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall")   # -flto
+  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wall")   # -flto
 ENDIF(STATIC)
 
 ##########################################
@@ -188,13 +203,29 @@
 IF(PYTB2)
   SET(WITH_MEM_JEMALLOC OFF)
   SET(MPI OFF)
+  SET(XCSP3 OFF)
   SET(LIBTB2 ON)
+  SET(Python3_FIND_STRATEGY LOCATION)
+  SET(Python3_FIND_FRAMEWORK NEVER)
   FIND_PACKAGE(Python3 COMPONENTS Interpreter Development)
-### Old cmake, python and pybind11
-  EXECUTE_PROCESS(
-    COMMAND ${Python3_EXECUTABLE}-config --extension-suffix 
-    OUTPUT_VARIABLE Python3_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
+
+  if(NOT Python3_Interpreter_FOUND)
+    MESSAGE(STATUS "Python3_Interpreter NOT FOUND")
+    SET(Python3_EXECUTABLE /usr/bin/python3)
+  else()
+    MESSAGE(STATUS "Python3_Interpreter FOUND")
+  endif()
+  MESSAGE(STATUS "Python3_EXECUTABLE: ${Python3_EXECUTABLE}")
+
+  if(EXISTS "${Python3_EXECUTABLE}-config")
+    SET(Python3_config "${Python3_EXECUTABLE}-config")
+    EXECUTE_PROCESS(COMMAND ${Python3_config} --extension-suffix OUTPUT_VARIABLE Python3_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
+  else()
+    EXECUTE_PROCESS(COMMAND ${Python3_EXECUTABLE} -c "import sysconfig;print(sysconfig.get_config_var('EXT_SUFFIX'))" OUTPUT_VARIABLE Python3_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
+  endif()
+
   MESSAGE(STATUS "Python3 suffix: ${Python3_SUFFIX}")
+
   EXECUTE_PROCESS(
     COMMAND ${Python3_EXECUTABLE} -m pybind11 --includes 
     OUTPUT_VARIABLE Pybind11_INCLUDES OUTPUT_STRIP_TRAILING_WHITESPACE)
@@ -213,60 +244,4 @@
 ENDIF(WITH_MEM_JEMALLOC)
 
 MESSAGE(STATUS "Search for GMP library")
-INCLUDE(FindPkgConfig)
-INCLUDE(${My_cmake_script}/FindGmp.cmake)
-SET(all_depends  ${all_depends} ${GMP_LIBRARY}) 
-INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR}) 
-
-INCLUDE(FindPkgConfig)
-INCLUDE(FindGit)
-
-IF(Boost) 
-  INCLUDE(${My_cmake_script}/Boost_option.cmake)
-  LINK_DIRECTORIES(${Boost_LIBRARY_DIR})
-  INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
-ENDIF(Boost)
-
-IF(MPI) 
-#  SET(CMAKE_C_COMPILER mpicc)
-#  SET(CMAKE_CXX_COMPILER mpicxx)
-#  SET(CMAKE_CXX_COMPILER /usr/mpi/gcc/openmpi-1.10.3rc4/bin/mpicxx)
-#  SET(CMAKE_SYSTEM_PREFIX_PATH /usr/mpi/gcc/openmpi-1.10.3rc4)
-  FIND_PACKAGE(MPI REQUIRED)
-  INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})
-  SET(mpiflag OPENMPI)
-ENDIF(MPI)
-
-INCLUDE(${My_cmake_script}/xmlcsp.cmake)
-
-
-##########################################
-# Build executables
-##########################################
-# the list of source files used to compile is set in source_file.cmake
-# new files need to be added to this list
-
-INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_SOURCE_DIR}/${My_Source} )
-
-IF(TOULBAR2)
-  ADD_LIBRARY(tb2-objects OBJECT ${LIBTB2FILES})
-  ADD_EXECUTABLE(toulbar2${EXE} ${My_Source}/tb2main.cpp $<TARGET_OBJECTS:tb2-objects>)
-  IF(STATIC)
-    TARGET_LINK_LIBRARIES(toulbar2${EXE} PUBLIC "-static")
-  ENDIF(STATIC)
-  ADD_LIBRARY(tb2-archive STATIC $<TARGET_OBJECTS:tb2-objects>)
-  ADD_CUSTOM_TARGET(gen_version ALL /bin/sh ${CMAKE_CURRENT_SOURCE_DIR}/cmake-script/genVersionFile.sh)
-  SET_SOURCE_FILES_PROPERTIES(ToulbarVersion.hpp PROPERTIES GENERATED 1)
-  ADD_DEPENDENCIES(toulbar2${EXE} gen_version)
-  IF(MPI)
-    TARGET_LINK_LIBRARIES(toulbar2${EXE} ${all_depends} ${MPI_LIBRARIES})
-    IF(MPI_COMPILE_FLAGS)
-      set_target_properties(toulbar2${EXE} PROPERTIES COMPILE_FLAGS "${MPI_COMPILE_FLAGS}")
-    ENDIF(MPI_COMPILE_FLAGS)
-    IF(MPI_LINK_FLAGS)
-      set_target_properties(toulbar2${EXE} PROPERTIES LINK_FLAGS "${MPI_LINK_FLAGS}")
-    ENDIF(MPI_LINK_FLAGS)
-  ELSE(MPI)
-    TARGET_LINK_LIBRARIES(toulbar2${EXE} ${all_depends})
-  ENDIF(MPI)
-
+find_package(PkgConfig)
