=== debian/control ===
--- 
+++ 
@@ -3,21 +3,27 @@
 Uploaders: Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper (>= 13~),
                cmake,
                bc,
                doxygen,
                doxygen-latex,
+               python3-sphinx,
+               python3-myst-parser,
+               python3-sphinx-rtd-theme,
+               python3-breathe,
+               latexmk,
+               tex-gyre,
                libgmp-dev,
                graphviz,
                libboost-graph-dev,
                libboost-iostreams-dev,
                libjemalloc-dev,
                zlib1g-dev,
+               libbz2-dev,
 	       liblzma-dev,
-               libxml2-dev,
                pkg-config
-Standards-Version: 4.3.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/toulbar2
 Vcs-Git: https://salsa.debian.org/science-team/toulbar2.git
 Homepage: http://www.inra.fr/mia/T/toulbar2
@@ -36,6 +42,7 @@
 Architecture: all
 Section: doc
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: Exact combinatorial optimization for Graphical Models - documentation
  Toulbar2 is  an exact discrete optimization tool for Graphical Models
  such as Cost Function Networks, Markov Random Fields, Weighted Constraint
