=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with=sphinxdoc

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
                -DXML=OFF \
		-DMPI=OFF \
		-DBUILD_API_DOC:STRING=ON \
		-DBUILD_API_DOC_LATEX:STRING=ON \
                -DBUILD_SPHINX_DOC:STRING=ON
